local Zifnabs_Config= {}
_G.Zifnabs_Config = Zifnabs_Config

local my_name="Zifnabs_Configuration"
getglobal(my_name.."_Head_Text"):SetText(Zifnabs.LANG.Config_TITLE)
getglobal(my_name.."_Release_Text"):SetText(Zifnabs_Settings.release)
getglobal(my_name.."_Select_1"):SetText(Zifnabs.LANG.Config_SELECT_MAIN)
getglobal(my_name.."_Main_Show_Text"):SetText(Zifnabs.LANG.Config_SHOW)
getglobal(my_name.."_Main_ShowRUI_Text"):SetText(Zifnabs.LANG.Config_SHOW_RUI)
getglobal(my_name.."_Main_Timer_Active_Text"):SetText(Zifnabs.LANG.Config_TIMER_ACTIVE)
getglobal(my_name.."_Main_Timer_HUD_Text"):SetText(Zifnabs.LANG.Config_HUD)
getglobal(my_name.."_Main_Timer_Sound_Text"):SetText(Zifnabs.LANG.Config_SOUND)
getglobal(my_name.."_SIA_Info_Text"):SetText(Zifnabs.LANG.Config_SIA_TEXT)
getglobal(my_name.."_SIA_Save"):SetText(Zifnabs.LANG.Config_SIA_SAVE)
getglobal(my_name.."_SIA_Ignore"):SetText(Zifnabs.LANG.Config_SIA_IGNORE)
getglobal(my_name.."_SIA_Abort"):SetText(Zifnabs.LANG.Config_SIA_ABORT)
local timer=my_name.."_Main_Timer"
getglobal(timer.."_Head_Time_Text"):SetText(Zifnabs.LANG.Config_TIMER_TIME)
getglobal(timer.."_Head_Text_Text"):SetText(Zifnabs.LANG.Config_TIMER_TEXT)
local config_frame=getglobal(my_name)
local main_frame=getglobal(my_name.."_Main")
local save_ignore_abort=getglobal(my_name.."_SIA")
local registered_menues={[1]=Zifnabs_Config}
local current_menu=0
local unsaved_changes=false
local redo=""
local last_registered_button=1

function Zifnabs_Config:register_module(caption,module)
	last_registered_button=last_registered_button+1
	local button=getglobal(my_name.."_Select_"..last_registered_button)
	button:SetText(caption)
	button:Show()
	registered_menues[last_registered_button]=module
end

-- ******************************************************************************************
-- * CONFIG Routinen
-- ******************************************************************************************
function Zifnabs_Config:select(menu)
	if config_frame:IsVisible()==true then
		if current_menu~=menu and current_menu~=0 then
			redo=menu
			registered_menues[current_menu]:leave()
			menu=nil
		end
	else
		Zifnabs_OnEvent("dummy","SAVE_VARIABLES")
		config_frame:Show()
		getglobal("Zifnabs_Main_Start_Config"):Disable()
	end
	if menu~=nil then
		for b=1,last_registered_button,1 do
			local button=getglobal(my_name.."_Select_"..b)
			if b==menu then button:Hide() else button:Show() end
			if b==menu then
				local point, relativePoint, scripts, x, y = button:GetAnchor()
				local selected=getglobal(my_name.."_Selected")
				selected:ClearAllAnchors()
				selected:SetAnchor(point, relativePoint, my_name, x, y)
				getglobal(my_name.."_Selected_Text"):SetText(button:GetText())
				getglobal(my_name.."_Selected_Text"):SetColor(1,1,1)
			end
		end
		registered_menues[menu]:enable()
		registered_menues[menu]:enter()
		current_menu=menu
	end
end

function Zifnabs_Config:close()
	if current_menu~=0 then 
		redo="*CLOSE*"
		registered_menues[current_menu]:leave()
	else
		config_frame:Hide()
		getglobal("Zifnabs_Main_Start_Config"):Enable()
		current_menu=0
	end
end

function Zifnabs_Config:left_menu()
	current_menu=0
	Zifnabs_Config:redo()
end

function Zifnabs_Config:redo()
	if redo=="*CLOSE*" then	Zifnabs_Config:close() else Zifnabs_Config:select(redo) end
end

function Zifnabs_Config:save_ignore_abort(func)
	if func=="ASK" then
		registered_menues[current_menu]:disable()
		save_ignore_abort:Show()
		Zifnabs:hud(nil,Zifnabs.LANG.Config_SIA_TEXT)
	else
		save_ignore_abort:Hide()
		getglobal(my_name):Enable()
		registered_menues[current_menu]:enable()
		if func=="SAVE" then
			registered_menues[current_menu]:save()
			Zifnabs_Config:redo()
		elseif func=="IGNORE" then
			registered_menues[current_menu]:ignore()
			Zifnabs_Config:redo()
		elseif func=="ABORT" then
			redo=0
		end
	end
end

function Zifnabs_Config:check(widget)
	local check,name,part=Zifnabs:parse_name(widget)
	local value=widget:IsChecked()
	if check=="main_show" then Zifnabs_Settings.visible=value
	elseif check=="main_showrui" then Zifnabs_Settings.reloadui=value
	elseif check=="timer_active" then Zifnabs_Settings.timer.active=value
	elseif check=="timer_hud" then Zifnabs_Settings.timer.hud=value
	elseif check=="timer_sound" then 
		if value==true then Zifnabs_Settings.timer.sound="remind.mp3" else Zifnabs_Settings.timer.sound="" end
	end
	Zifnabs:reload_settings()
end

function Zifnabs_Config:button(widget)
	local button,name,part=Zifnabs:parse_name(widget)
	if button=="edit_save" then
		local func="hud"
		local time=getglobal(timer.."_Edit_Time"):GetText()
		local seconds=0
		for number in string.gmatch(time, "%d+") do
			seconds=60*seconds+number
		end
		local text=getglobal(timer.."_Edit_Text"):GetText()
		Zifnabs:timer("add",time,"timer",text)
		Zifnabs_Config:enter()
	elseif string.lower(part[#part-1])=="delete" then 
		Zifnabs:echo("L�schen ist nicht implementiert")
	else 
		Zifnabs:echo(button.." p-1="..part[#part-1])
	end
end

function Zifnabs_Config:changes(widget)
	unsaved_changes=true
end

-- ******************************************************************************************
-- * Routinen für REGISTERED_MENUs
-- ******************************************************************************************
function Zifnabs_Config:enter()
	local main=main_frame:GetName()
	getglobal(main.."_Show"):SetChecked(Zifnabs_Settings.visible)
	getglobal(main.."_ShowRUI"):SetChecked(Zifnabs_Settings.reloadui)
	getglobal(main.."_Timer_Active"):SetChecked(Zifnabs_Settings.timer.active)
	getglobal(main.."_Timer_HUD"):SetChecked(Zifnabs_Settings.timer.hud)
	local value=true
	if Zifnabs_Settings.timer.sound=="" then value=false end
	getglobal(main.."_Timer_Sound"):SetChecked(value)
	local list,now=Zifnabs:timer("get")
	local ts=0
	for t=1,9,1 do
		local clear=getglobal(timer.."_List_Time_"..t.."_Text")
		if clear~=nil then
			clear:SetText("")
			getglobal(timer.."_List_Text_"..t.."_Text"):SetText("")
		end
		local time=""
		local func=""
		local text=""
		if t<=#list then
			time=math.floor(list[t]["time"]-now)
			func=list[t]["function"]
			text=list[t]["parm"]
			if time>60 then time=math.floor(time/60)..":"..(time-60*math.floor(time/60)) end
		end
		if func=="timer" then
			ts=ts+1
			local ltime=getglobal(timer.."_List_Time_"..ts.."_Text")
			if ltime~=nil then
				ltime:SetText(time)
				getglobal(timer.."_List_Text_"..ts.."_Text"):SetText(text)
			end
		end
	end
	getglobal(timer.."_Edit_Time"):SetText("")
	getglobal(timer.."_Edit_Text"):SetText("")
	main_frame:Show()
	unsaved_changes=false
end

function Zifnabs_Config:leave()
	if unsaved_changes then 
		Zifnabs_Config:save_ignore_abort("ASK") 
	else 
		main_frame:Hide()
		Zifnabs_Config:left_menu()
	end
end

function Zifnabs_Config:save() Zifnabs_Config:button(getglobal(timer.."_Edit_Save")) end
function Zifnabs_Config:ignore()	unsaved_changes=false end
function Zifnabs_Config:disable() main_frame:Disable() end
function Zifnabs_Config:enable()	main_frame:Enable() end
