local Zifnabs_Config_RP = {}
_G.Zifnabs_Config_RP = Zifnabs_Config_RP

local config_frame=getglobal("Zifnabs_Configuration")
local my_name="Zifnabs_Configuration_RP"
local my_frame=getglobal(my_name)
local unsaved_changes=false

local categories={"notarget","any","female","male"}
local get_category={}
for c=1,#categories,1 do
	get_category[c]=categories[c]
	get_category[categories[c]]=c
end
local selected_button=1
local selected_category=2
local reset_texts=true

getglobal(my_name.."_Buttons_left"):SetText("←")
getglobal(my_name.."_Buttons_right"):SetText("→")
getglobal(my_name.."_Buttons_up"):SetText("↑")
getglobal(my_name.."_Buttons_down"):SetText("↓")
getglobal(my_name.."_Edit_Button_Label_Text"):SetText(Zifnabs.LANG.Config_RP_EDITBUTTON)
getglobal(my_name.."_Edit_Button_Label_Text"):SetColor(0.9,0.8,0.2)
getglobal(my_name.."_Edit_Save"):SetText(Zifnabs.LANG.Config_RP_SAVE)

Zifnabs_Config:register_module(Zifnabs.LANG.Config_RP_SELECT,Zifnabs_Config_RP)

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************
function Zifnabs_Config_RP:check(widget)
	local id,name,part=Zifnabs:parse_name(widget)
	local value=widget:IsChecked()
end

function Zifnabs_Config_RP:button(widget)
	local id,name,part=Zifnabs:parse_name(widget)
	local last=part[#part]
	local pref=part[#part-1]
	if id=="edit_save" then Zifnabs_Config_RP:save()
	elseif pref=="category" then
		local category=get_category[last]
		Zifnabs_Config_RP:switchto(selected_button,category)
	elseif last=="flip" then
		if Zifnabs_Settings.rp_say[selected_button] then
			if Zifnabs_Settings.rp_say[selected_button][pref]==nil then
				Zifnabs_Settings.rp_say[selected_button][pref]={}
				Zifnabs_Config_RP:switchto(selected_button,selected_category)
			else
				if #Zifnabs_Settings.rp_say[selected_button][pref]==0 then 
					Zifnabs_Settings.rp_say[selected_button][pref]=nil
					if get_category[selected_category]==pref then selected_category=2 end
					Zifnabs_Config_RP:switchto(selected_button,selected_category)
				else
					Zifnabs:error(Zifnabs.LANG.Config_RP_NOTEMPTY)
				end
			end
		end
	elseif pref=="Buttons" and (last=="left" or last=="right" or last=="up" or last=="down") then
		local new=nil
		if last=="left" and selected_button%3~=1 then new=selected_button-1
		elseif last=="right" and selected_button%3~=0 then new=selected_button+1
		elseif last=="up" and selected_button>3 then new=selected_button-3
		elseif last=="down" and selected_button<10 then new=selected_button+3
		end
		if new~=nil then
			local temp=Zifnabs_Settings.rp_say[new]
			Zifnabs_Settings.rp_say[new]=Zifnabs_Settings.rp_say[selected_button]
			Zifnabs_Settings.rp_say[selected_button]=temp
			selected_button=new
			reset_texts=false
			Zifnabs_Config_RP:switchto(selected_button,category)
		end
	elseif pref=="Buttons" then Zifnabs_Config_RP:switchto(1*last,2)
	end
end

function Zifnabs_Config_RP:switchto(button,category)
	selected_button=button
	selected_category=category
	Zifnabs_RP:reload_settings()
	Zifnabs_Config_RP:enter()
end

function Zifnabs_Config_RP:changes(what)
	if what==nil or what==false then
		unsaved_changes=false
		getglobal(my_name.."_Edit_Save"):Disable()
	else
		unsaved_changes=true
		getglobal(my_name.."_Edit_Save"):Enable()	
	end
end

-- ******************************************************************************************
-- * API Funktionen für Zifnabs_Config
-- ******************************************************************************************
function Zifnabs_Config_RP:enter()
	my_frame:Show()
	-- Buttons anzeigen
	for b=1,12,1 do
		local button=getglobal(my_name.."_Buttons_"..b)
		button:SetText(Zifnabs_Settings.rp_say[b]["caption"])
		if b~=selected_button then button:Show()
		else
			button:Hide()
			local point, relativePoint, scripts, x, y, more = button:GetAnchor()
			local bsel=getglobal(my_name.."_Buttons_selected")
			bsel:ClearAllAnchors()
			local anchor=""
			if b==4 or b==7 or b==10 then anchor="_"..(b-3)
			elseif b>1 then	anchor="_"..(b-1)
			end
			bsel:SetAnchor(point, relativePoint, my_name.."_Buttons"..anchor, x, y)
			local caption=button:GetText()
			if caption=="" then caption="???" end
			getglobal(my_name.."_Buttons_selected_Text"):SetText(caption)
			getglobal(my_name.."_Buttons_selected_Text"):SetColor(1,1,1)
			if reset_texts==true then getglobal(my_name.."_Edit_Button"):SetText(button:GetText()) end
		end
	end
	
	-- Kategorien anzeigen
	for c=1,4,1 do
		local category=categories[c]
		local button=getglobal(my_name.."_Buttons_category_"..category)
		local caption=Zifnabs.LANG["Config_RP_"..category]
		button:SetText(caption)
		if c==selected_category then
			button:Hide()
			local point, relativePoint, scripts, x, y = button:GetAnchor()
			local csel=getglobal(my_name.."_Buttons_category_selected")
			csel:ClearAllAnchors()
			csel:SetAnchor(point, relativePoint, my_name.."_Buttons", x, y)
			getglobal(my_name.."_Buttons_category_selected_Text"):SetText(button:GetText())
			getglobal(my_name.."_Buttons_category_selected_Text"):SetColor(1,1,1)
		else
			button:Show()
			local enable=true
			if Zifnabs_Settings.rp_say[selected_button]~=nil then
				if Zifnabs_Settings.rp_say[selected_button][category]==nil then enable=false end
			end
			if enable then button:Enable() else button:Disable() end
		end
	end
	
	-- Texte anzeigen
	if reset_texts==true then
		category=categories[selected_category]
		for t=1,20,1 do
			local edit=getglobal(my_name.."_Say_"..t)
			local text=""
			if Zifnabs_Settings.rp_say[selected_button][category]~=nil then text=Zifnabs_Settings.rp_say[selected_button][category][t] end
			if edit~=nil then edit:SetText(text) end
		end
		Zifnabs_Config_RP:changes(false)
	end
	reset_texts=true
end

function Zifnabs_Config_RP:leave()
	if unsaved_changes then Zifnabs_Config:save_ignore_abort("ASK")  
	else 
		my_frame:Hide()
		Zifnabs_Config:left_menu()
	end
end
function Zifnabs_Config_RP:save()
	local table={}
	for t=1,20,1 do
		local edit=getglobal(my_name.."_Say_"..t)
		if edit~=nil then
			local text=edit:GetText()
			if text~="" and text~=nil then table[#table+1]=text end
		end
	end
	local category=get_category[selected_category]
	local caption=getglobal(my_name.."_Edit_Button"):GetText()
	if caption==nil then caption="" end

	Zifnabs_Settings.rp_say[selected_button]["caption"]=caption
	Zifnabs_Settings.rp_say[selected_button][category]=table
	Zifnabs_RP:reload_settings()
	Zifnabs_Config_RP:enter()
end
function Zifnabs_Config_RP:ignore() Zifnabs_Config_RP:changes(false) end
function Zifnabs_Config_RP:disable() my_frame:Disable() end
function Zifnabs_Config_RP:enable() my_frame:Enable() end
